﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Collections.Generic;

public partial class PlugIns_Security_security_settings : System.Web.UI.UserControl
{
    private string _userName;
    private AdminPanelSettings apSettings = new AdminPanelSettings();

    protected bool _isServerExist = false;
    protected bool _isWebMailExist = false;

    protected string UserName
    {
        get { return _userName; }
        set { _userName = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        _isServerExist = Utils.IsPluginExist("Server");
        _isWebMailExist = Utils.IsPluginExist("WebMail");

        apSettings.LoadAdminPanelSettings();
        UserName = apSettings.User;
        txtPassword.Attributes.Add("value", AdminConstants.DummyPassword);
        txtPasswordConfirm.Attributes.Add("value", AdminConstants.DummyPassword);
        txtHost.Value = apSettings.Host;
        txtPort.Value = apSettings.Port;

        if (!_isServerExist)
        {
            trHost.Visible = false;
            trPort.Visible = false;
        }
    }

    public void SaveSettings(object sender, System.EventArgs e)
    {
        bool flag = false;
        if (txtPassword.Text.Trim() != AdminConstants.DummyPassword)
        {
            if (_isServerExist)
            {
                try
                {
                    if (ControlAccounts.IsControlAccountExist(UserName))
                        ControlAccounts.SetControlAccountPassword(UserName, txtPassword.Text);
                    else
                    {
                        ControlAccounts.ControlAccount ca = new ControlAccounts.ControlAccount();
                        ca.Name = UserName;
                        ca.Password = txtPassword.Text;
                        ControlAccounts.AddControlAccount(ca);
                    }
                    flag = true;
                }
                catch (Exception ex)
                {
                    flag = false;
                    Utils.SetPageErrorMessage(Page, ex.Message);
                }
                if (flag)
                    apSettings.Pass = txtPassword.Text;
            }
            else
            {
                apSettings.Pass = txtPassword.Text;
            }
        }
        if (_isServerExist)
        {
            apSettings.Host = txtHost.Value;
            apSettings.Port = txtPort.Value;
        }
        try
        {
            apSettings.SaveAdminPanelSettings();
            Utils.SetPageReportMessage(Page, "Settings are successfully saved!");
        }
        catch(Exception ex)
        {
            Utils.SetPageErrorMessage(Page, ex.Message);
        }
    }

}
