﻿using System;
using System.IO;


public partial class serverLite_integration : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());
        if (!Page.IsPostBack)
        {
            txtWmServerRootPath.Value = settings.WmServerRootPath;
            txtWmServerHostName.Value = settings.WmServerHost;
        }
        else
        {
            Trace.Write("Mail Server settings is postback");
        }
    }
    
    protected void save_ServerClick(object sender, EventArgs e)
    {
        try
        {
            WebMailLite.WebmailSettings settings = new WebMailLite.WebmailSettings().CreateInstance(Utils.GetWebMailDataFolder());

            settings.WmServerRootPath = txtWmServerRootPath.Value;
            settings.WmServerHost = txtWmServerHostName.Value;

            if (!settings.EnableWmServer)
            {
                settings.SaveWebmailSettings(Utils.GetWebMailDataFolder());
                Utils.SetPageReportMessage(this.Page, WebMailLite.Constants.mailAdmSaveSuccess);
            }
            else if (txtWmServerRootPath.Value.Length > 0)
            {
                string fullPath = Path.Combine(txtWmServerRootPath.Value, "domains");
                if (!Directory.Exists(fullPath))
                {
                    throw new WebMailLite.WebMailIOException(string.Format(@"Server Root Path '{0}' incorrect.", Utils.EncodeHtml(fullPath)));
                }
                WebMailPro.Utils.SettingsPath = Utils.GetWebMailDataFolder();
                WebMailLite.WMServerStorage storage = new WebMailLite.WMServerStorage(txtWmServerHostName.Value, null);
                storage.GetDomainList(); // test command

                settings.SaveWebmailSettings(Utils.GetWebMailDataFolder());

                Utils.SetPageReportMessage(this.Page, WebMailLite.Constants.mailAdmSaveSuccess);
            }
            else
            {
                throw new WebMailLite.WebMailIOException(@"Server Root Path not set.");
            }

        }
        catch (Exception ex)
        {
            Utils.SetPageErrorMessage(this.Page, WebMailLite.Constants.mailAdmSaveUnsuccess + "<br /> Error:" + ex.Message);
        }
    }
}
