﻿using System;
using System.Web.UI;
using System.Globalization;

public partial class PlugIns_WebMailLite_main : MainPlugin
{
	public enum MailAdmScreen
	{
		WebMailSettings = 3,
		InterfaceSettings = 4,
		LoginSettings = 5,
		DebugSettings = 6,
		MailServer = 8
	}

    protected PlugIns_WebMailLite_main()
    {
        SetPluginID("WebMailLite");
    }

    protected MailAdmScreen _screen = MailAdmScreen.WebMailSettings;

	protected webmailLite_settings wmSettingsID;
	protected interfaceLite_settings ifcSettingsID;
	protected loginLite_settings lgnSettingsID;
	protected debugLite_settings dbgSettingsID;
    protected serverLite_integration inegrSettingsID;
    protected WebMailLite.WebmailSettings settings;

	protected void Page_Load(object sender, EventArgs e)
	{
		string mode = this.Request.QueryString["mode"];
		if (mode != null)
		{
			if (string.Compare(mode, "webmail", true, CultureInfo.InvariantCulture) == 0)
			{
				_screen = MailAdmScreen.WebMailSettings;

                Control ctrl = LoadControl(@"Controls\webmail_settings.ascx");
				wmSettingsID = ctrl as webmailLite_settings;
				if (wmSettingsID != null)
				{
					wmSettingsID.ID = "wmSettingsID";
					ContentPlaceHolder.Controls.Add(wmSettingsID);
				}
			}
			else if (string.Compare(mode, "interface", true, CultureInfo.InvariantCulture) == 0)
			{
				_screen = MailAdmScreen.InterfaceSettings;

                Control ctrl = LoadControl(@"Controls\interface_settings.ascx");
				ifcSettingsID = ctrl as interfaceLite_settings;
				if (ifcSettingsID != null)
				{
					ifcSettingsID.ID = "ifcSettingsID";
					ContentPlaceHolder.Controls.Add(ifcSettingsID);
				}
			}
			else if (string.Compare(mode, "login", true, CultureInfo.InvariantCulture) == 0)
			{
				_screen = MailAdmScreen.LoginSettings;

                Control ctrl = LoadControl(@"Controls\login_settings.ascx");
				lgnSettingsID = ctrl as loginLite_settings;
				if (lgnSettingsID != null)
				{
					lgnSettingsID.ID = "lgnSettingsID";
					ContentPlaceHolder.Controls.Add(lgnSettingsID);
				}
			}
			else if (string.Compare(mode, "debug", true, CultureInfo.InvariantCulture) == 0)
			{
				_screen = MailAdmScreen.DebugSettings;

                Control ctrl = LoadControl(@"Controls\debug_settings.ascx");
				dbgSettingsID = ctrl as debugLite_settings;
				if (dbgSettingsID != null)
				{
					dbgSettingsID.ID = "dbgSettingsID";
					ContentPlaceHolder.Controls.Add(dbgSettingsID);
				}
			}
			else if (string.Compare(mode, "integration", true, CultureInfo.InvariantCulture) == 0)
			{
				_screen = MailAdmScreen.MailServer;

                Control ctrl = LoadControl(@"Controls\server_integration.ascx");
                inegrSettingsID = ctrl as serverLite_integration;
                if (inegrSettingsID != null)
				{
                    inegrSettingsID.ID = "inegrSettingsID";
                    ContentPlaceHolder.Controls.Add(inegrSettingsID);
				}
			}
			MenuID.Screen = (int)_screen;
		}
		else
		{
            Response.Redirect("adminpanel.aspx?mode=webmail");
		}
	}

}
