﻿String.prototype.trim = function () {
	if (this != null)
	{
		return this.replace(/^\s+/, '').replace(/\s+$/, '');
	}
	return this;
};

function OnlyNumAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if (Trim(obj.value) != '') 
        {
            // Allow symbol 0-9
            temp_value = Trim(obj.value).replace(/[^0-9]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                obj.value = temp_value;
            }
            else
            {
                Tip.Hide('');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 003');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyNum_OnKeyUp(obj)
{
    try
    {
        Tip.Hide('');
        var temp_value;
        //obj.value = Trim(obj.value);
        if (Trim(obj.value) != '') 
        {
            // Allow symbol 0-9
            temp_value = Trim(obj.value).replace(/[^0-9]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                Tip.Show("Please type digits only", obj, '');
            }
            else
            {
                Tip.Hide('');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 004');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyFloatNumAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if (Trim(obj.value) != '') 
        {
            // Allow symbol 0-9 and '.'
            temp_value = Trim(obj.value).replace(/[^0-9.]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                obj.value = temp_value;
                //Tip.Show("Please type digits only", obj, '');
            }
            else
            {
                Tip.Hide('');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 005');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyCommaSeparatedNumAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if (Trim(obj.value) != '') 
        {
            // Allow symbol 0-9 and '.'
            temp_value = Trim(obj.value).replace(/[^0-9,]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                obj.value = temp_value;
                //Tip.Show("Please type digits only", obj, '');
            }
            else
            {
                Tip.Hide('');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 006');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyCommaSeparatedIPAllow(obj)
{
    try
    {
        var temp_value;
        if (obj.value != '') 
        {
            //obj.value = Trim(obj.value);
            var arrIP = new Array();
            var i=0;
            arrIP = Trim(obj.value).split(",");
            if (arrIP.length > 0) 
            {
                for(i=0; i < arrIP.length; i++)
                {
                    if(!IsIPAddress(arrIP[i])) 
                    {
                        Tip.Show("Only IP Addresses or comma separated IP Addresses allowing here", obj, '');
                        break;
                    }
                }
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 007');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyCommaSeparatedIPAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if (Trim(obj.value) != '') 
        {
            // Allow symbol 0-9 and '.'
            temp_value = Trim(obj.value).replace(/[^0-9,.]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                Tip.Show("Only IP Addresses or comma separated IP Addresses allowing here", obj, '');
            }
            else
            {
                Tip.Hide('');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 008');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyDomainSymbolsAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if (Trim(obj.value) != '') 
        {
            temp_value = Trim(obj.value).replace(/[^A-Za-z0-9_.-]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                Tip.Show("Incorrect characters in the domain name", obj, '');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 009');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function ServerSettings_OnlyDomainSymbolsAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if(AllDomainNamesIsOk()) 
        {
        }
        if (Trim(obj.value) != '') 
        {
            temp_value = Trim(obj.value).replace(/[^A-Za-z0-9_.-]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                Tip.Show("Incorrect characters in the domain name", obj, '');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 010');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function ServerSettings_OnlyEmailSymbolsAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if(EmailAddressIsOk(obj)) 
        {
        }
        if (Trim(obj.value) != '') 
        {
            temp_value = Trim(obj.value).replace(/[^A-Za-z0-9_.@-]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                Tip.Show("Incorrect characters in the email address", obj, '');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 011');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function ExternalPop3Server_OnKeyUp(obj, elem)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        elem.disabled = false;
        if (Trim(obj.value) != '') 
        {
            temp_value = Trim(obj.value).replace(/[^A-Za-z0-9_.-]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                elem.disabled = true;
                Tip.Show("Incorrect character for an External POP3 Server", obj, '');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 012');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyUsersSymbolsAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);

        if (Trim(obj.value) != '') 
        {
            temp_value = Trim(obj.value).replace(/[^A-Za-z0-9_.-]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                Tip.Show("Incorrect character for an User/Account Name", obj, '');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 013');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function OnlyAdminsAccountSymbolsAllow_OnKeyUp(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        //if(ServerSettingsUsersPasswordIsOk(document.getElementById('UserPassword_PassMode'))) 
        //{
            //document.getElementById('ServerSettingsID_AddAdminAccountButtonID').disabled = false;
        //}
        if (Trim(obj.value) != '') 
        {
            temp_value = Trim(obj.value).replace(/[^A-Za-z0-9_.-]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                //document.getElementById('ServerSettingsID_AddAdminAccountButtonID').disabled = true;
                Tip.Show("Incorrect character for an User/Account Name", obj, '');
            }
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 014');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function AdminsAccountSymbolsIsOk(obj)
{
    try
    {
        var temp_value;
        //obj.value = Trim(obj.value);
        if (Trim(obj.value) != '') 
        {
            temp_value = Trim(obj.value).replace(/[^A-Za-z0-9_.-]/gi, "");
            if (temp_value != Trim(obj.value))
            {
                //obj.value = temp_value;
                //document.getElementById('ServerSettingsID_AddAdminAccountButtonID').disabled = true;
                return false
            }
        }
        else
        {
                //document.getElementById('ServerSettingsID_AddAdminAccountButtonID').disabled = true;
                return false
        }
        return true;
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 015');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function IsDomainName(sDomainName)
{
    try
    {
        //---------------------------------------------------------------    
        sDomainName = "" + sDomainName;
        sDomainName = Trim(sDomainName);
        var arrTest = new Array();
        arrTest = sDomainName.split(".");
        if (arrTest.length > 0) 
        {
            if(arrTest[0] == "" || arrTest[arrTest.length - 1] == "") return false;
        }
        //---------------------------------------------------------------
        
        var temp_value;
        if (sDomainName != '') 
        {
            temp_value = sDomainName.replace(/[^A-Za-z0-9_.-]/gi, "");
            if (temp_value != sDomainName)
            {
                sDomainName = temp_value;
                return false;
            }
            else
            {
                Tip.Hide('');
                return true;
            }
        }
        else return false;
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 016');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function IsDomainMaskOk(sDomainName)
{
    try
    {
        //---------------------------------------------------------------    
        sDomainName = "" + sDomainName;
        sDomainName = sDomainName.trim();
        var arrTest = new Array();
        arrTest = sDomainName.split(".");
        if (arrTest.length > 0) 
        {
            if(arrTest[0] == "" || arrTest[arrTest.length - 1] == "") return false;
        }
        //---------------------------------------------------------------
        
        var temp_value;
        if (sDomainName != '') 
        {
            temp_value = sDomainName.replace(/[^A-Za-z0-9_.*-]/gi, "");
            if (temp_value != sDomainName)
            {
                sDomainName = temp_value;
                return false;
            }
            else
            {
                Tip.Hide('');
                return true;
            }
        }
        else return false;
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 171');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function IsIPAddress(sIPValue)
{
    try
    {
        var blnError = false;
        var sErrorString = "";
        var theName = "IPaddress";

        var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
        var aIpArray = sIPValue.match(ipPattern);
        var thisSegment;

        if (sIPValue == "0.0.0.0")
        {
            blnError = true;
        }
        else if (sIPValue == "255.255.255.255")
        {
            blnError = true;
        }
        
        if (aIpArray == null)
        {
            blnError = true;
        }
        else 
        {
            for (i = 1; i < 5; i++)//because element aIpArray[0] - is the hole ip address!!!
            {
                thisSegment = aIpArray[i];
                if (thisSegment > 255) 
                {
                    blnError = true;
                    i = 4;
                }
                if ((i == 0) && (thisSegment > 255)) 
                {
                    blnError = true;
                    i = 4;
                }
            }
        }
        if (blnError)
        {
            return false;
        }
        else
        {
            return true;
        }
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 017');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function IsEmailAddress(obj, emailStr)
{
    try
    {   
        if (emailStr != '') 
        {
            emailStr = Trim(emailStr);
            var arrIP = new Array();
            var index=0;
            arrIP = emailStr.split("@");
            if (arrIP.length == 2) 
            {
                if(IsDomainMaskOk(arrIP[0]))
                {
                    index++;
                }
                if(IsDomainMaskOk(arrIP[1]))
                {
                    index++;
                }
                if(index < 2)
                { 
                    if(!IsDomainMaskOk(emailStr))
                    {
                        Tip.Show("Incorrect characters in the input field", obj, '');
                        return false;
                    }
                    else
                    {
                        //if user type more than one *//
                        obj.value = ConvertDataToNormalView(emailStr);
                        return true;
                    }
                }
                else
                {
                    //if user type more than one *//
                    obj.value = ConvertDataToNormalView(emailStr);
                    return true;
                }
            }
            else
            {
                if(!IsDomainMaskOk(emailStr))
                {
                    Tip.Show("Incorrect characters in the input field", obj, '');
                    return false;
                }
                else 
                {
                    //if user type more than one *//
                    obj.value = ConvertDataToNormalView(emailStr);
                    return true;
                }
            }
        }
        else return true;
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 018');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function ConvertDataToNormalView(param)
{
    try
    {
        var i=0;
        var result = "";
        if(param.length < 2)
        {
            return param;
        }
        for(i=1; i < param.length; i++)
        {
            if(param.charAt(i-1) == '*' && param.charAt(i) == '*')
            {
                if(result.charAt(result.length-1) != '*') result += '*';
                i++;
            }
            else if(param.charAt(i-1) == '*' && param.charAt(i) != '*')
            {
                if(result.charAt(result.length-1) != '*') result += '*';
            }
            else
            {
                result += param.charAt(i-1);
            }
        }
        if(i != 0) result += param.charAt(i-1);
        return result;
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 172');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function EmailAddressIsOk(obj)
{
	try
	{
		return !EmailAddressIsIncorrect(obj, Trim(obj.value));
	}
	catch(errorMsg)
	{
		MsgBox.Show(ErrorPrefix + ' 020');
	}
}
//----------------------------------------------------------------------------------------------------------------------------------------------
function EmailAddressIsIncorrect(obj, emailStr)
{
    try
    {
        if (emailStr != '')
        {
            emailStr = Trim(emailStr);
            var arrIP = new Array();
            var index=0;
            arrIP = emailStr.split("@");
            if (arrIP.length == 2) 
            {
                if(IsDomainName(arrIP[0]))
                {
                    index++;
                }
                if(IsDomainName(arrIP[1]))
                {
                    index++;
                }
                if(index < 2)
                { 
                    return true;
                }
                else
                    return false;
            }
            else
            {
                return true;
            }
        }
        else return false;
    }
    catch(errorMsg)
    {
        MsgBox.Show(ErrorPrefix + ' 021');
    }
}
//----------------------------------------------------------------------------------------------------------------------------------------------