using System;
using System.Globalization;
using System.IO;
using System.Web;
using MailBee.Mime;

namespace WebMailLite
{
	/// <summary>
	/// Summary description for download_view_attachment.
	/// </summary>
	public class download_view_attachment : System.Web.UI.Page
	{
		private void Page_Load(object sender, System.EventArgs e)
		{
			string userAgent;//Client browser
			string temp_filename = Request.QueryString["temp_filename"];
			if (temp_filename != null)
			{
				try
				{
					byte[] buffer = new byte[0];
					object tempFolder = Utils.GetTempFolderName(this.Session);
					if (tempFolder != null)
					{
						string safe_temp_file_name=Path.GetFileName(temp_filename);

						string fullPath = Path.Combine(tempFolder.ToString(), safe_temp_file_name);
						if (File.Exists(fullPath))
						{
							using(FileStream fs = File.OpenRead(fullPath))
							{
								buffer = new byte[fs.Length];
								fs.Read(buffer, 0, buffer.Length);
							}
						}
					}
					else
					{
						return;
					}
					string filename = (Request.QueryString["filename"] != null) ? Request.QueryString["filename"] : temp_filename;
					string download = Request.QueryString["download"];

					string encodedFilename = filename;
					userAgent = Request.UserAgent;
//					if (userAgent.IndexOf("MSIE") > -1) 
//					{
//						encodedFilename = Server.UrlPathEncode(filename);
//					}
					if(userAgent.IndexOf("MSIE") <0)
						encodedFilename=Server.HtmlEncode(filename);

					if (download != null)
					{
						Response.Clear();

						if (string.Compare(download, "1", true, CultureInfo.InvariantCulture) == 0)
						{
							Response.ClearHeaders();
							Response.ContentEncoding=System.Text.Encoding.UTF8;
							{
								Response.AppendHeader("Expires", "0");
								Response.AppendHeader("Cache-Control", "must-revalidate, post-check=0, pre-check=0");
								Response.AppendHeader("Pragma", "public");
							}

							Response.ContentType = "application/octet-stream";
							Response.AppendHeader("Content-Disposition", "attachment; filename=\""+encodedFilename+"\"");
							Response.AppendHeader("Accept-Ranges", "bytes");
							Response.AppendHeader("Content-Length", buffer.Length.ToString());
							Response.AppendHeader("Content-Transfer-Encoding", "binary");
							
						}
						else
						{
							string ext = Path.GetExtension(filename);
							if ((ext != null) && (ext.Length > 0))
							{
								ext = ext.Substring(1, ext.Length - 1); // remove first dot
							}
							Response.ContentType = Utils.GetAttachmentMimeTypeFromFileExtension(ext);
						}
					}
					Response.BufferOutput=true;
					Response.OutputStream.Write(buffer,0,buffer.Length);
					//Response.BinaryWrite(buffer);
					Response.Flush();
					//Response.End();
				}
				catch(Exception ex)
				{
					Log.WriteException(ex);
				}
			}
			else
			{
				if ((Request.QueryString["uid"] != null))
				{
					try
					{
						MailMessage msg = null;
						BaseWebMailActions actions = new BaseWebMailActions(Session[Constants.sessionAccount] as Account, this.Page);
						msg = actions.GetMessage(HttpUtility.UrlDecode(Request.QueryString["uid"]), -1);

						if (msg != null)
						{
                            string subj = msg.Subject;
                            //\, /, ?, |, *, <, >, :
                            string safeSubject = string.Empty;
                            for (int i = 0; i < subj.Length; i++)
                            {
                                if (subj[i] == '\\' || subj[i] == '|' || subj[i] == '/' ||
                                    subj[i] == '?' || subj[i] == '*' || subj[i] == '<' ||
                                    subj[i] == '>' || subj[i] == ':')
                                {
                                    continue;
                                }
                                else
                                {
                                    safeSubject += subj[i];
                                }
                            }
                            safeSubject = safeSubject.TrimStart();
                            if (safeSubject.Length > 30)
                            {
                                safeSubject = safeSubject.Substring(0, 30).TrimEnd();
                            }
                            safeSubject = safeSubject.TrimEnd(new char[2] { '.', ' ' });
                            if (safeSubject.Length == 0)
                            {
                                safeSubject = "message";
                            }

                            string encodedMsgFilename = string.Empty;
                            userAgent = Request.UserAgent;
                            if (userAgent.IndexOf("MSIE") > -1)
                            {
                                encodedMsgFilename = Server.UrlPathEncode(safeSubject);
                                Response.AddHeader("Expires", "0");
                                Response.AddHeader("Cache-Control", "must-revalidate, post-check=0, pre-check=0");
                                Response.AddHeader("Pragma", "public");
                            }
                            else
                            {
                                encodedMsgFilename = safeSubject;
                            }
                            //**************************************************************
                            byte[] buffer = msg.GetMessageRawData();
                            //**************************************************************
                            Response.Clear();
                            Response.ContentType = "application/octet-stream";
                            Response.AddHeader("Accept-Ranges", "bytes");
                            Response.AddHeader("Content-Length", buffer.Length.ToString(CultureInfo.InvariantCulture));
                            Response.AddHeader("Content-Disposition", string.Format(@"attachment; filename=""{0}.eml""", encodedMsgFilename));
                            Response.AddHeader("Content-Transfer-Encoding", "binary");
                            Response.BinaryWrite(buffer);
                            Response.Flush();
						}
					} catch {}
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}