using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using MailBee.Mime;

namespace WebMailLite 
{
	/// <summary>
	/// Summary description for msgprint.
	/// </summary>
	public class msgprint : System.Web.UI.Page {
		protected WebmailResourceManager _manager = null;
		protected MailMessage msg = null;
		Account acct = null;
		protected bool IsHTMLMsg = false;
		protected string msgPlain = null;
		protected string msgHTML = null;
		protected System.Web.UI.WebControls.Literal MessageBody;
		protected System.Web.UI.WebControls.Literal LabelFrom;
		protected System.Web.UI.WebControls.Literal LabelTo;
		protected System.Web.UI.WebControls.Literal LabelDate;
		protected System.Web.UI.WebControls.Literal LabelSubject;

		private void Page_Load(object sender, System.EventArgs e) {
			bool showPicturesSettings = false;
			acct = Session[Constants.sessionAccount] as Account;
			if (acct == null) {
				Response.Redirect("default.aspx");
			}
			else {
				_manager = (new WebmailResourceManagerCreator()).CreateResourceManager();
				string uid = string.Empty;
				int charset = -1;
				if (Request.QueryString["uid"] != null)
				{
					uid = Request.QueryString["uid"];
					charset = Convert.ToInt32(Request.QueryString["charset"]);
				}
				else
				{
					uid = (string)Session["uid"];
					charset = (int)Session["charset"];
				}

				try {
					IsHTMLMsg = false;
					msgPlain = null;
					msgHTML = null;
					BaseWebMailActions bwml = new BaseWebMailActions(acct, this.Page);
					if (showPicturesSettings)
						msg = bwml.GetMessage(uid, charset, 1);
					else
						msg = bwml.GetMessage(uid, charset);
					LabelFrom.Text = Server.HtmlEncode(msg.From.ToString());
					LabelTo.Text = Server.HtmlEncode(msg.To.ToString());
					LabelDate.Text = Utils.GetDateWithOffsetFormatString(acct, msg.Date);
					LabelSubject.Text = Server.HtmlEncode(msg.Subject);
					msgPlain = Utils.MakeHtmlBodyFromPlainBody(msg.BodyPlainText);
					msgHTML = msg.BodyHtmlText;
					if(msgPlain == " ") {
						msgPlain = Utils.ConvertHtmlToPlain(msgHTML);
					}
					if(msgHTML != "") {
						IsHTMLMsg = true;
						//Message body
						MessageBody.Text= msgHTML;
					}
					else {
						IsHTMLMsg = false;
						MessageBody.Text = msgPlain;
					}
				}
				catch (Exception ex) {
					Log.WriteException(ex);
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e) {
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
